/* Problem URL: https://codeforces.com/gym/101845/problem/F */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

const int oo = INT32_MAX >> 1;
const ll OO = INT64_MAX >> 1;


void pre()
{

}

#define TEST 0

void solve()
{
    int n;
    cin >> n;

    auto count = [&](string &a, int c[26]) {
        repv(i, a) {
            c[i - 'A']++;
        }
    };

    V<tuple<int, ll, ll>> edges;
    vvi graph(n + 28);
    int sz = graph.size();

    int s = 0;
    int t = n + 27;

    auto add_edge = [&](int u, int v, ll c) {
        graph[u].push_back(edges.size());
        edges.emplace_back(v, c, 0);
        graph[v].push_back(edges.size());
        edges.emplace_back(u, 0, 0);
    };

    vl pos(n);
    rep(i, n) {
        string a, b, c;
        cin >> a >> b >> c;

        add_edge(s, i + 1, 1);

        int cc[26] = {0};

        count(a, cc);
        count(b, cc);
        count(c, cc);

        int ma = *max_element(cc, cc + 26);

        rep(j, 26) {
            if (cc[j] == ma) {
                add_edge(i + 1, j + n + 1, 1);
            }
        }
    }

    int k;
    cin >> k;

    rep(i, 26) {
        add_edge(i + n + 1, t, k);
    }

    vi lvl(sz, oo);
    vi p(sz);

    auto bfs = [&]() {
        lvl[s] = 0;
        queue<int> q;
        q.push(s);

        while (!q.empty()) {
            auto i = q.front();
            q.pop();

            repv(id, graph[i]) {
                auto [j, l, c] = edges[id];
                if (l != c && lvl[j] > lvl[i] + 1) {
                    lvl[j] = lvl[i] + 1;
                    q.push(j);
                }
            }
        }

        return lvl[t] != oo;
    };

    function<ll(int, ll)> dfs = [&](int i, ll f) {
        if (f == 0) {
            return 0LL;
        }

        if (i == t) {
            return f;
        }

        for (int &d = p[i]; d < graph[i].size(); d++) {
            int id = graph[i][d];
            auto &[j, l, c] = edges[id];

            if (l == c || lvl[j] <= lvl[i]) {
                continue;
            }

            ll fr = dfs(j, min(f, l - c));
            if (fr == 0) {
                continue;
            }

            c += fr;
            auto &[_, __, c2] = edges[id^1];
            c2 -= fr;

            return fr;
        }

        return 0LL;
    };

    ll ans = 0;

    while (1) {
        fill(all(lvl), oo);
        if (!bfs()) {
            break;
        }

        fill(all(p), 0);
        ll add = 0;
        while ((add = dfs(s, OO)) != 0) {
            ans += add;
        }
    };

    cout << ans << '\n';
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    pre();

    int t;
    (TEST && cin >> t) || (t = 1);
    while (t--) {
        solve();
    }
}
